Bacula 1.30 User's Guide | Chapter 4

Getting Started | Index | Bacula Configuration

# Installing Bacula

## General

In general, you will need the Bacula source release, and if you want to run a Windows client, you will need the Bacula Windows binary release. However, Bacula needs certain third party packages (such as readline, SQLite, MySQL to build properly depending on the options you specify. To simplify your task, we have combined a number of these packages into two depkgs releases (Dependency Packages). This can vastly simplify your life by providing you with all the necessary packages rather than requiring you to find them on the Web, load them, and install them.

## Dependency Packages

As discussed above, we have combined a number of third party packages that Bacula might need into the depkgs and depkgs1 releases. Typically, they will be named depkgs-ddMMMyy.tar.gz and depkgs1-ddMMyy.tar.gz where dd is the day we release it, MMM is the abbreviated month (e.g. Jan), and yy is the year. An actual example is: depkgs-07Apr02.tar.gz. To install and build this package (if needed), you do the following:

1. Create a bacula directory, into which you will place both the Bacula source as well as the dependency package.
2. Detar the depkg into the bacula directory.
3. cd bacula/depkgs
4. make

Although the exact composition of the dependency packages may change from time to time, the current makeup is the following:

3rd Party Package | depkgs | depkgs1
--- | --- | ---
SQLite | X | -
mtx | X | -
readline | - | X

Note, some of these packages are quite large, so that this part can be a bit time consuming. The above instructions will build all the packages contained in the directory. However, when building Bacula, it will take only those pieces that it actually needs.

Alternatively, you can make just the packages that are needed. For example,

    cd bacula/depkgs
    make sqlite

will configure and build only the SQLite package.

You should build the packages that you will require in depkgs and/or depkgs1 prior to configuring and building Bacula, since Bacula will need them during the build process.

Even if you do not use SQLite, you might find it worth while to build mtx because the tapeinfo program that comes with it can often provide you with valuable information about your SCSI tape drive (e.g. compression, min/max block sizes, ...).

## Operating Systems Supported

Bacula is supported on the following operating systems:

     - Linux (RedHat, Gentoo)
     - Solaris
     - Win98, WinNT, WinXP, WinMe, Win2K (Client only)
     - FreeBSD

In addition, Bacula is known to build and run on the following systems.

     - OpenBSD
     - Irix
     - Darwin
     - AIX

## Building Bacula from Source

The basic installation is rather simple.

1. Install and build any depkgs as noted above.
2. Configure and install MySQL (if desired). Installing and Configuring MySQL Phase I. This is necessary so that the MySQL header files are available while compiling Bacula.
   Note, if you already have a running MySQL on your system, you can skip this phase.
3. As an alternative to MySQL, configure and install SQLite, which is part of the depkgs. Installing and Configuring SQLite.
4. Detar the Bacula source code preferably into the bacula directory discussed above.
5. cd to the directory containing the source code.
6. ./configure (with appropriate options as described below)
7. Check the output of ./configure very carefully, especially the Install binaries and Install config files directories. If they are not correct, please rerun ./configure until they are. The output from ./configure is stored in config.out and can be re-displayed at any time without rerunning the ./configure by doing cat config.out.
8. make

   If you get errors while linking in the Storage daemon directory (src/stored), it is probably because you have not loaded the static libraries on your system. I noticed this problem on a Solaris system. To correct it, make sure that you have not added enable-static-tools to the ./configure command.

9. make install
10. Create valid configuration files for each of the three daemons (Directory, File, Storage) and for the Console program. For the details of how to do this, please see Setting Up Bacula Configuration Files in the Configuration chapter of this manual. We recommend that you start by modifying the default configuration files supplied. Please take care when modifying passwords, which were randomly generated, and the daemon Names as the passwords and names must agree between the configuration files for security reasons.
11. Create the Bacula MySQL databases and tables (if using MySQL) Installing and Configuring MySQL Phase II or alternatively if you are using SQLite Installing and Configuring SQLite Phase II.
12. Start Bacula (./bacula start)
13. Interface with Bacula using the Console program

If all goes well, the ./configure will correctly determine which operating system you are running and configure the source code appropriately. Currently, FreeBSD, Linux (RedHat), and Solaris are supported.

If you install Bacula on more than one system, and they are identical, you can simply transfer the source tree to that other system and do a "make install". However, if there are differences in the libraries or OS versions, or you wish to install on a different OS, you should start from the original compress tar file. If you do transfer the source tree, and you have previously done a ./configure command, you MUST do:

    make distclean

prior to doing your new ./configure. This is because the GNU autoconf tools cache the configuration, and if you re-use a configuration for a Linux machine on a Solaris, you can be sure your build will fail. To avoid this, as mentioned above, either start from the tar file, or do a "make distclean".

In general, you will probably want to supply a more complicated configure statement to ensure that the modules you want are built and that everything is placed into the correct directories.

For example, on RedHat, one could use the following:

    CFLAGS="-g -Wall" \
      ./configure \
        --sbindir=$HOME/bacula/bin \
        --sysconfdir=$HOME/bacula/bin \
        --with-pid-dir=$HOME/bacula/bin/working \
        --with-subsys-dir=$HOME/bacula/bin/working \
        --with-mysql=$HOME/mysql \
        --with-working-dir=$HOME/bacula/bin/working \
        --with-dump-email=$USER

For the developer's convenience, I have added a defaultconfig script to the examples directory. This script script contains the statements that you would normally use, and each developer/user may modify them to suit his needs. You should find additional useful examples in this directory as well.

## What Database to Use?

Before building Bacula you need to decide if you want to use SQLite or MySQL. If you are not already running MySQL, we recommend that you start by using SQLite. This will greatly simplify the setup for you.

If you wish to use MySQL as the Bacula catalog, please see the Installing and Configuring MySQL chapter of this manual. You will need to install MySQL prior to continuing with the configuration of Bacula.

If you wish to use SQLite as the Bacula catalog, please see Installing and Configuring SQLite chapter of this manual.

## Configure Options

The following command line options are available for configure to customize your installation.

--sysbindir=<binary-path>
  Defines where the Bacula binary (executable) files will be placed during a make install command.
--sysconfdir=<config-path>
  Defines where the Bacula configuration files should be placed during a make install command.
--enable-smartalloc
  This enables the inclusion of the Smartalloc orphaned buffer detection code. This option is highly recommended. Because we never build without this option, you may experience problems if it is not enabled. This configuration parameter is used while building Bacula
--enable-gnome
  If you have GNOME installed on your computer and you want to use the GNOME GUI Console interface to Bacula, you must specify this option. Doing so will build everything in the src/gnome-console directory.
--enable-static-tools
  This option causes the linker to link the Storage daemon utility tools (bls, bextract, and bscan) statically. This permits using them without having the shared libraries loaded. If you have problems linking in the src/stored directory, make sure you have not enabled this option, or explicitly disable static linking by adding --disable-static-tools.
--enable-static-fd
  This option causes the make process to build a static-bacula-fd in addition to the standard File daemon. This static version will include statically linked libraries and is required for the Bare Metal recovery. This option is largely superceded by using make static-bacula-fd from with in the src/filed directory. Also, the --enable-client-only option described below is useful for just building a client so that all the other parts of the program are not compiled.
--enable-static-sd
  This option causes the make process to build a static-bacula-sd in addition to the standard Storage daemon. This static version will include statically linked libraries and could be useful during a Bare Metal recovery.
--enable-static-dir
  This option causes the make process to build a static-bacula-dir in addition to the standard Director. This static version will include statically linked libraries and could be useful during a Bare Metal recovery.
--enable-static-cons
  This option causes the make process to build a static-console and a static-gnome-console in addition to the standard console. This static version will include statically linked libraries and could be useful during a Bare Metal recovery.
--enable-client-only
  This option causes the make process to build only the File daemon and the libraries that it needs. None of the other daemons, storage tools, nor the console will be build. Likewise a make install will then only install the File daemon. To cause all daemons to be built, you will need to do a configuration without this option. This option greatly facilitates building a Client on a client only machine.
--enable-largefile
  This option (default) causes Bacula to be built with 64 bit file address support if it is available on your system. This permits Bacula to read and write files greater than 2 GBytes in size. You may disable this feature and revert to 32 bit file addresses by using --disable-largefile.
--with-sqlite=<sqlite-path>
  This enables use of the SQLite database. The sqlite-path is not normally specified as Bacula looks for the necessary components in a standard location (depkgs/sqlite). See Installing and Configuring MySQL chapter of this manual for more details.
--with-mysql=<mysql-path>
  This enables building of the Catalog services for Bacula. It assumes that MySQL is running on your system, and expects it to be installed in the mysql-path that you specify. If this option is not present, the build will automatically include the internal Bacula database code. We recommend that you use this option if possible. If you do use this option, please proceed to installing MySQL in the Installing and Configuring MySQL chapter before proceeding with the configuration.
--with-readline=<readline-path>
  Tells Bacula where where readline is installed. Normally, Bacula will find readline if it is in a standard library. If it is not found and no --with-readline is specified, readline will be disabled. This option affects the Bacula build.
--with-tcp-wrappers=<path>
  This specifies that you want TCPWrappers compiled in (untested). The path is optional since Bacula will normally find the libraries in the standard locations. This option affects the Bacula build. Please note that this option has not been fully tested.
--with-working-dir=<working-directory-path>
  This option is mandatory and specifies a directory into which Bacula may safely place files that will remain between Bacula executions. For example, if the internal database is used, Bacula will keep those files in this directory. This option is only used to modify the daemon configuration files. You may also accomplish the same thing by directly editing them later.
--with-base-port=<port=number>
  In order to run, Bacula needs three TCP/IP ports (one for the Bacula Console, one for the Storage daemon, and one for the File daemon). The --with-baseport option will automatically assign three ports beginning at the base port address specified. You may also change the port number in the resulting configuration files. However, you need to take care that the numbers correspond correctly in each of the three daemon configuration files. The default base port is 9101, which assigns ports 9101 through 9103. These ports (9101, 9102, and 9103) have been officially assigned to Bacula by IANA. This option is only used to modify the daemon configuration files. You may also accomplish the same thing by directly editing them later.
--with-dump-email=<email-address>
  This option specifies the email address where any core dumps should be set. This option is normally only used by developers.
--with-pid-dir=<PATH>
  This specifies where Bacula should place the process id file during execution. The default is: /var/run.
--with-subsys-dir=<PATH>
  This specifies where Bacula should place the subsystem lock file during execution. The default is /var/run/subsys. Please make sure that you do not specify the same directory for this directory and for the sbindir directory.
--with-dir-password=<Password>
  This option allows you to specify the password used to access the Directory (normally from the Console program). If it is not specified, configure will automatically create a random password.
--with-fd-password=<Password>
  This option allows you to specify the password used to access the File daemon (normally called from the Director). If it is not specified, configure will automatically create a random password.
--with-sd-password=<Password>
  This option allows you to specify the password used to access the Directory (normally called from the Director). If it is not specified, configure will automatically create a random password.

Note, many other options are presented when you do a ./configure --help, but they are not implemented.

## Recommended Options for most Systems

For most systems, we recommend starting with the following options:

    ./configure \
      --enable-smartalloc \
      --sbindir=$HOME/bacula/bin \
      --sysconfdir=$HOME/bacula/bin \
      --with-pid-dir=$HOME/bacula/bin/working \
      --with-subsys-dir=$HOME/bacula/bin/working \
      --with-mysql=$HOME/mysql \
      --with-working-dir=$HOME/bacula/working

If you want to install Bacula in an installation directory rather than run it out of the build directory (as developers will do most of the time), you should also include the --sbindir and --sysconfdir options with appropriate paths. Neither are necessary if you do not use "make install" as is the case for most development work. See below for an example of how Kern does it.

## RedHat

Using SQLite:

    CFLAGS="-g -Wall" ./configure \
      --sbindir=$HOME/bacula/bin \
      --sysconfdir=$HOME/bacula/bin \
      --enable-smartalloc \
      --with-sqlite=$HOME/bacula/depkgs/sqlite \
      --with-working-dir=$HOME/bacula/working \
      --with-pid-dir=$HOME/bacula/bin/working \
      --with-subsys-dir=$HOME/bacula/bin/working

or

    CFLAGS="-g -Wall" ./configure \
      --sbindir=$HOME/bacula/bin \
      --sysconfdir=$HOME/bacula/bin \
      --enable-smartalloc \
      --with-mysql=$HOME/mysql \
      --with-working-dir=$HOME/bacula/working
      --with-pid-dir=$HOME/bacula/bin/working \
      --with-subsys-dir=$HOME/bacula/bin/working

## Solaris

    CFLAGS="-g" ./configure \
      --sbindir=$HOME/bacula/bin \
      --sysconfdir=$HOME/bacula/bin \
      --with-mysql=$HOME/mysql \
      --enable-smartalloc \
      --with-pid-dir=$HOME/bacula/bin/working \
      --with-subsys-dir=$HOME/bacula/bin/working \
      --with-working-dir=$HOME/bacula/working

## Win32

Please note that as of this time (28 April 2003), on certain systems such as WinXP and most likely Win2K, Bacula will restore files with the userid that Bacula is using namely SYSTEM. This means that you may not be able to access those restored files until you change the owner to be your userid.

To install the binary Win32 version of the File daemon please see the Win32 Installation Chapter in this document.

## Windows Systems with CYGWIN Installed

If you wish to build from the source, and if you have CYGWIN version 1.3.20 and GCC 2.95.3-5 installed, it is possible to build the Win32 version of Bacula on a Windows machine. Please don't try any other versions of CYGWIN or GCC as there were known problems. In addition, Bacula is designed to be installed on a non-CYGWIN system. If you do install it on a system with CYGWIN installed, you are on your own, and you must take special care to install Bacula in the main CYGWIN directory (normally c:\cygwin) rather than in the root (c:\).

To date, the Win32 version has only been build on Win98 SR2, WinMe, and WinXP Home systems with the above CYGWIN environment and all the available CYGWIN tools loaded. In addition, the builds were done running under the bash shell. As time permits, we will experiment with other environments, and if any of you do build it from source, please let us know. The current CYGWIN environment was loaded using the CYGWIN setup.exe program, downloading ALL the latest binaries and installing them.

Note, although most parts of Bacula build on Windows systems, the only part that we have tested and used is the File daemon.

We recommend that you run the ./configure command with the following options:

    ./configure \
      --sbindir=/bacula/bin \
      --sysconfdir=/bacula/bin \
      --with-working-dir=/bacula/working \
      --with-pid-dir=/bacula/working \
      --with-subsys-dir=/bacula/working \
      --enable-smartalloc

Note, the automatic installation for Win32 is not yet written, so most of these specifications are not really used.

After which, you can do a:

    make

To create a binary tar release, do the following:

    cd src/filed/win32
    make binary-release

It will tell you where it has placed the binary release.

All the daemons will be built, but the only one tested to date is the Win32 File daemon. For the other daemons, you are on your own. It is not very probable they will work.

Finally, you should follow the installation instructions in the Win32 Installation section of this document, skipping the part that describes unZipping the binary release.

## Kern's Configure Script

The script that I use for building on my "production" Linux machines is:

    CFLAGS="-g -Wall" \
      ./configure \
        --sbindir=$HOME/bacula/bin \
        --sysconfdir=$HOME/bacula/bin \
        --enable-gnome \
        --with-pid-dir=$HOME/bacula/bin/working \
        --with-subsys-dir=$HOME/bacula/bin/working \
        --with-mysql=$HOME/mysql \
        --with-working-dir=$HOME/bacula/bin/working \
        --with-dump-email=$USER \
        --with-baseport=9101
    exit 0

Note that I define the base port as 9101, which means that Bacula will use port 9101 for the Director console, port 9102 for the File daemons, and port 9103 for the Storage daemons. These ports should be available on all systems because they have been officially assigned to Bacula by IANA (Internet Assigned Numbers Authority). We strongly recommend that you use only these ports to prevent any conflicts with other programs. This is in fact the default if you do not specify a --with-baseport option.

You may also want to put the following entries in your /etc/services file as it will make viewing the connections made by Bacula easier to recognize (i.e. netstat -a):

    bacula-dir      9101/tcp
    bacula-fd       9102/tcp
    bacula-sd       9103/tcp

## Building a File Daemon or Client

If you run the Director and the Storage daemon on one machine and you wish to back up another machine, you must have a copy of the File daemon for that machine. If the machine and the Operating System are identical, you can simply copy the Bacula File daemon binary file bacula-fd as well as its configuration file bacula-fd.conf then modify the name and password in the conf file to be unique. Be sure to make corresponding additions to the Director's configuration file (bacula-dir.conf).

If the architecture or the O/S level are different, you will need to build a File daemon on the Client machine. To do so, you can use the same ./configure command as you did for your main program, starting either from a fresh copy of the source tree, or using make distclean before the ./configure.

Since the File daemon does not access the Catalog database, you can remove the --with-mysql or --with-sqlite options, then add --enable-client-only. This will compile only the necessary libraries and the client programs and thus avoids the necessity of installing one or another of those database programs to build the File daemon. With the above option, you simply enter make and just the client will be built.

## Auto Starting the Daemons

If you wish the daemons to be automatically started and stopped when your system is booted (a good idea), one more step is necessary. First, the ./configure process must recognize your system -- that is it must be a supported platform and not unknown, then you must install the platform dependent files by doing:

    (become root)
    make install-autostart

Please note, that the auto-start feature is implemented only on systems that we officially support (currently, FreeBSD, RedHat Linux, and Solaris), and has only been fully tested on RedHat Linux.

The make install-autostart will cause the appropriate startup scripts to be installed with the necessary symbolic links. On RedHat Linux systems, these scripts reside in /etc/rc.d/init.d/bacula-dir /etc/rc.d/init.d/bacula-fd, and /etc/rc.d/init.d/bacula-sd. However the exact location depends on what operating system you are using.

If you only wish to install the File daemon, you may do so with:

    make install-autostart-fd

## Other Make Notes

To simply build a new executable in any directory, enter:

    make

To clean out all the objects and binaries (including the files named 1, 2, or 3, which Kern uses as temporary files), enter:

    make clean

To really clean out everything for distribution, enter:

    make distclean

note, this cleans out the Makefiles and is normally done from the top level directory to prepare for distribution of the source. To recover from this state, you must redo the ./configure in the top level directory, since all the Makefiles will be deleted.

To add a new file in a subdirectory, edit the Makefile.in in that directory, then simply do a make. In most cases, the make will rebuild the Makefile from the new Makefile.in. In some case, you may need to issue the make a second time. In extreme cases, cd to the top level directory and enter: make Makefiles.

To add dependencies:

    make depend

The make depend appends the header file dependencies for each of the object files to Makefile and Makefile.in. This command should be done in each directory where you change the dependencies. Normally, it only needs to be run when you add or delete source or header files. make depend is normally automatically invoked during the configuration process.

To install:

    make install

This not normally done if you are developing Bacula, but is used if you are going to run it to backup your system.

After doing a make install the following files will be installed on your system (more or less). The exact files and location (directory) for each file depends on your ./configure command (e.g. gnome-console and gnome-console.conf are not installed if you do not configure GNOME. Also, if you are using SQLite instead of mysql, some of the files will be different).

    bacula
    bacula-dir
    bacula-dir.conf
    bacula-fd
    bacula-fd.conf
    bacula-sd
    bacula-sd.conf
    bextract
    bls
    bscan
    btape
    btraceback
    btraceback.gdb
    console
    console.conf
    create_mysql_database
    dbcheck
    delete_catalog_backup
    drop_bacula_tables
    drop_mysql_tables
    fd
    gnome-console
    gnome-console.conf
    make_bacula_tables
    make_catalog_backup
    make_mysql_tables
    mtx-changer
    query.sql
    smtp
    startmysql
    stopmysql

# Modifying the Bacula Configuration Files

See the chapter Configuring Bacula in this manual for instructions on how to set Bacula configuration files.

Getting Started | Index | Bacula Configuration

Bacula 1.30 User's Guide The Network Backup Solution | Copyright © 2000-2003 Kern Sibbald and John Walker